# [PATCH] Fix to push --progress. The --progress flag was not being passed into tranport.c from send-pack.h, making the --progress flag unusable

41 messages from 2010-10-12 to 2010-10-22. Participants: Chase Brammer, Jonathan Nieder, Junio C Hamano, Jeff King, Tay Ray Chuan, Ævar Arnfjörð Bjarmason.
Thread: https://gitlist.dev/t/25432

## Chase Brammer, 2010-10-12 22:21

Subject: [PATCH] Fix to push --progress. The --progress flag was not being passed into tranport.c from send-pack.h, making the --progress flag unusable
Message-ID: <AANLkTin9_kofdy49WF4V_JoovVR+G8DN7vn-cz3p84fz@mail.gmail.com>
URL: https://gitlist.dev/e/AANLkTin9_kofdy49WF4V_JoovVR%2BG8DN7vn-cz3p84fz%40mail.gmail.com

```
The result of this is external tools and tools writing standard error
to a file from bash would not be able to receive progress information
during a push.  Similar functionality is seen in fetch, which still
works.

An example that previously would output no information for --progress:
git push origin master --progress > ~/push_error_output.txt 2>&1

The above example and others now work with this patch.

Helped-by: Jeff King <peff@peff.net>
Helped-by: Jonathan Nieder <jrnieder@gmail.com>
Signed-off-by: Chase Brammer <cbrammer@gmail.com>
---
 builtin/send-pack.c |    3 +++
 send-pack.h         |    1 +
 transport.c         |    1 +
 3 files changed, 5 insertions(+), 0 deletions(-)

diff --git a/builtin/send-pack.c b/builtin/send-pack.c
index 481602d..efd9be6 100644
--- a/builtin/send-pack.c
+++ b/builtin/send-pack.c
@@ -48,6 +48,7 @@ static int pack_objects(int fd, struct ref *refs,
struct extra_have_objects *ext
 		NULL,
 		NULL,
 		NULL,
+		NULL,
 	};
 	struct child_process po;
 	int i;
@@ -59,6 +60,8 @@ static int pack_objects(int fd, struct ref *refs,
struct extra_have_objects *ext
 		argv[i++] = "--delta-base-offset";
 	if (args->quiet)
 		argv[i++] = "-q";
+	if (args->progress)
+		argv[i++] = "--progress";
 	memset(&po, 0, sizeof(po));
 	po.argv = argv;
 	po.in = -1;
diff --git a/send-pack.h b/send-pack.h
index 60b4ba6..fcf4707 100644
--- a/send-pack.h
+++ b/send-pack.h
@@ -4,6 +4,7 @@
 struct send_pack_args {
 	unsigned verbose:1,
 		quiet:1,
+		progress:1,
 		porcelain:1,
 		send_mirror:1,
 		force_update:1,
diff --git a/transport.c b/transport.c
index 4dba6f8..0078660 100644
--- a/transport.c
+++ b/transport.c
@@ -789,6 +789,7 @@ static int git_transport_push(struct transport
*transport, struct ref *remote_re
 	args.use_thin_pack = data->options.thin;
 	args.verbose = (transport->verbose > 0);
 	args.quiet = (transport->verbose < 0);
+	args.progress = transport->progress;
 	args.dry_run = !!(flags & TRANSPORT_PUSH_DRY_RUN);
 	args.porcelain = !!(flags & TRANSPORT_PUSH_PORCELAIN);

-- 
1.7.3.1

```

## Jonathan Nieder, 2010-10-12 22:44

Subject: Re: [PATCH] Fix to push --progress. The --progress flag was not being passed into tranport.c from send-pack.h, making the --progress flag unusable
Message-ID: <20101012224456.GC15587@burratino>
URL: https://gitlist.dev/e/20101012224456.GC15587%40burratino
In-Reply-To: <AANLkTin9_kofdy49WF4V_JoovVR+G8DN7vn-cz3p84fz@mail.gmail.com>

```
Chase Brammer wrote:

> The result of this is external tools and tools writing standard error
> to a file from bash would not be able to receive progress information
> during a push.  Similar functionality is seen in fetch, which still
> works.

A bit of protocol: since the patch is by Jeff, this should have

	From: Jeff King <peff@peff.net>

at the beginning of the log message.  See Documentation/SubmittingPatches
for details.

> Helped-by: Jonathan Nieder <jrnieder@gmail.com>

I didn't help. :)

>  builtin/send-pack.c |    3 +++
>  send-pack.h         |    1 +
>  transport.c         |    1 +
>  3 files changed, 5 insertions(+), 0 deletions(-)

It's not necessary by any means, but it would be nice to add a test
for this to t/ so no one breaks the new functionality in the future.

Thanks.

```

## Junio C Hamano, 2010-10-13 17:49

Subject: Re: [PATCH] Fix to push --progress. The --progress flag was not being passed into tranport.c from send-pack.h, making the --progress flag unusable
Message-ID: <7vr5fum19m.fsf@alter.siamese.dyndns.org>
URL: https://gitlist.dev/e/7vr5fum19m.fsf%40alter.siamese.dyndns.org
In-Reply-To: <AANLkTin9_kofdy49WF4V_JoovVR+G8DN7vn-cz3p84fz@mail.gmail.com>

```
Chase Brammer <cbrammer@gmail.com> writes:

> The result of this is external tools and tools writing standard error

Thanks for leaving a record in the list archive, but (1) what Jonathan
said, plus (2) Please do something about that overlong Subject: line.

```

## Jeff King, 2010-10-13 17:55

Subject: Re: [PATCH] Fix to push --progress. The --progress flag was not being passed into tranport.c from send-pack.h, making the --progress flag unusable
Message-ID: <20101013175508.GA14035@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101013175508.GA14035%40sigill.intra.peff.net
In-Reply-To: <7vr5fum19m.fsf@alter.siamese.dyndns.org>

```
On Wed, Oct 13, 2010 at 10:49:09AM -0700, Junio C Hamano wrote:

> Chase Brammer <cbrammer@gmail.com> writes:
> 
> > The result of this is external tools and tools writing standard error
> 
> Thanks for leaving a record in the list archive, but (1) what Jonathan
> said, plus (2) Please do something about that overlong Subject: line.

Actually, I was initially trying to foist testing and patch submission
off on somebody else because I didn't want to spend more time on it. But
I ended up doing it anyway, and I think I will have a two-patch series.
This one (with tests), and one to make --no-progress. I'll try to work
it up this afternoon.

-Peff

```

## Tay Ray Chuan, 2010-10-13 18:40

Subject: Re: [PATCH] Fix to push --progress. The --progress flag was not being passed into tranport.c from send-pack.h, making the --progress flag unusable
Message-ID: <AANLkTim-0wzsX1XxbjXEyf0hg+5T5P_yPCoaNQ2ReKV5@mail.gmail.com>
URL: https://gitlist.dev/e/AANLkTim-0wzsX1XxbjXEyf0hg%2B5T5P_yPCoaNQ2ReKV5%40mail.gmail.com
In-Reply-To: <AANLkTin9_kofdy49WF4V_JoovVR+G8DN7vn-cz3p84fz@mail.gmail.com>

```
Hi,

On Wed, Oct 13, 2010 at 6:21 AM, Chase Brammer <cbrammer@gmail.com> wrote:
> The result of this is external tools and tools writing standard error
> to a file from bash would not be able to receive progress information
> during a push.  Similar functionality is seen in fetch, which still
> works.
>
> An example that previously would output no information for --progress:
> git push origin master --progress > ~/push_error_output.txt 2>&1
>
> The above example and others now work with this patch.
>
> Helped-by: Jeff King <peff@peff.net>
> Helped-by: Jonathan Nieder <jrnieder@gmail.com>
> Signed-off-by: Chase Brammer <cbrammer@gmail.com>

The long subject line not withstanding, your patch seems corrupt.

Guess I'll have to write it by hand.

-- 
Cheers,
Ray Chuan

```

## Jonathan Nieder, 2010-10-13 19:30

Subject: Re: [PATCH 1/3] t5523-push-upstream: add function to ensure fresh upstream repo
Message-ID: <20101013193039.GA8941@burratino>
URL: https://gitlist.dev/e/20101013193039.GA8941%40burratino
In-Reply-To: <1286998311-5112-2-git-send-email-rctay89@gmail.com>

```
Tay Ray Chuan wrote:

> --- a/t/t5523-push-upstream.sh
> +++ b/t/t5523-push-upstream.sh
> @@ -3,8 +3,14 @@
>  test_description='push with --set-upstream'
>  . ./test-lib.sh
>  
> +ensure_fresh_upstream() {
> +	test -d parent &&
> +	rm -rf parent
> +	git init --bare parent
> +}

Wouldn't

	rm -rf parent &&
	git init --bare parent

do it?

```

## Tay Ray Chuan, 2010-10-13 19:31

Subject: [PATCH 0/3] fix push --progress over file://, git://, etc.
Message-ID: <1286998311-5112-1-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1286998311-5112-1-git-send-email-rctay89%40gmail.com
In-Reply-To: <AANLkTin9_kofdy49WF4V_JoovVR+G8DN7vn-cz3p84fz@mail.gmail.com>

```
*** BLURB HERE ***

Contents:
[PATCH 1/3] t5523-push-upstream: add function to ensure fresh upstream repo
[PATCH 2/3] t5523-push-upstream: test progress messages
[PATCH 3/3] push: pass --progress down to git-pack-objects

 builtin/send-pack.c      |    3 +++
 send-pack.h              |    1 +
 t/t5523-push-upstream.sh |   24 +++++++++++++++++++++++-
 transport.c              |    1 +
 4 files changed, 28 insertions(+), 1 deletions(-)

--
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-13 19:31

Subject: [PATCH 1/3] t5523-push-upstream: add function to ensure fresh upstream repo
Message-ID: <1286998311-5112-2-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1286998311-5112-2-git-send-email-rctay89%40gmail.com
In-Reply-To: <1286998311-5112-1-git-send-email-rctay89@gmail.com>

```
Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
---
 t/t5523-push-upstream.sh |    8 +++++++-
 1 files changed, 7 insertions(+), 1 deletions(-)

diff --git a/t/t5523-push-upstream.sh b/t/t5523-push-upstream.sh
index 00da707..337a69e 100755
--- a/t/t5523-push-upstream.sh
+++ b/t/t5523-push-upstream.sh
@@ -3,8 +3,14 @@
 test_description='push with --set-upstream'
 . ./test-lib.sh
 
+ensure_fresh_upstream() {
+	test -d parent &&
+	rm -rf parent
+	git init --bare parent
+}
+
 test_expect_success 'setup bare parent' '
-	git init --bare parent &&
+	ensure_fresh_upstream &&
 	git remote add upstream parent
 '
 
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-13 19:31

Subject: [PATCH 2/3] t5523-push-upstream: test progress messages
Message-ID: <1286998311-5112-3-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1286998311-5112-3-git-send-email-rctay89%40gmail.com
In-Reply-To: <1286998311-5112-2-git-send-email-rctay89@gmail.com>

```
Reported-by: Chase Brammer <cbrammer@gmail.com>
Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
---
 t/t5523-push-upstream.sh |   16 ++++++++++++++++
 1 files changed, 16 insertions(+), 0 deletions(-)

diff --git a/t/t5523-push-upstream.sh b/t/t5523-push-upstream.sh
index 337a69e..554f55e 100755
--- a/t/t5523-push-upstream.sh
+++ b/t/t5523-push-upstream.sh
@@ -72,4 +72,20 @@ test_expect_success 'push -u HEAD' '
 	check_config headbranch upstream refs/heads/headbranch
 '
 
+test_expect_failure 'progress messages to non-tty' '
+	ensure_fresh_upstream &&
+
+	# skip progress messages, since stderr is non-tty
+	git push -u upstream master >out 2>err &&
+	! grep "Writing objects" err
+'
+
+test_expect_failure 'progress messages to non-tty (forced)' '
+	ensure_fresh_upstream &&
+
+	# force progress messages to stderr, even though it is non-tty
+	git push -u --progress upstream master >out 2>err &&
+	grep "Writing objects" err
+'
+
 test_done
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-13 19:31

Subject: [PATCH 3/3] push: pass --progress down to git-pack-objects
Message-ID: <1286998311-5112-4-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1286998311-5112-4-git-send-email-rctay89%40gmail.com
In-Reply-To: <1286998311-5112-3-git-send-email-rctay89@gmail.com>

```
From: Jeff King <peff@peff.net>

When pushing via builtin transports (like file://, git://), the
underlying transport helper (in this case, git-pack-objects) did not get
the --progress option, even if it was passed to git push.

Fix this, and update the tests to reflect this.

Note that according to the git-pack-objects documentation, we can safely
apply the usual --progress semantics for the transport commands like
clone and fetch (and for pushing over other smart transports).

Reported-by: Chase Brammer <cbrammer@gmail.com>
Helped-by: Jonathan Nieder <jrnieder@gmail.com>
Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
---
 builtin/send-pack.c      |    3 +++
 send-pack.h              |    1 +
 t/t5523-push-upstream.sh |    4 ++--
 transport.c              |    1 +
 4 files changed, 7 insertions(+), 2 deletions(-)

diff --git a/builtin/send-pack.c b/builtin/send-pack.c
index 481602d..efd9be6 100644
--- a/builtin/send-pack.c
+++ b/builtin/send-pack.c
@@ -48,6 +48,7 @@ static int pack_objects(int fd, struct ref *refs, struct extra_have_objects *ext
 		NULL,
 		NULL,
 		NULL,
+		NULL,
 	};
 	struct child_process po;
 	int i;
@@ -59,6 +60,8 @@ static int pack_objects(int fd, struct ref *refs, struct extra_have_objects *ext
 		argv[i++] = "--delta-base-offset";
 	if (args->quiet)
 		argv[i++] = "-q";
+	if (args->progress)
+		argv[i++] = "--progress";
 	memset(&po, 0, sizeof(po));
 	po.argv = argv;
 	po.in = -1;
diff --git a/send-pack.h b/send-pack.h
index 60b4ba6..05d7ab1 100644
--- a/send-pack.h
+++ b/send-pack.h
@@ -5,6 +5,7 @@ struct send_pack_args {
 	unsigned verbose:1,
 		quiet:1,
 		porcelain:1,
+		progress:1,
 		send_mirror:1,
 		force_update:1,
 		use_thin_pack:1,
diff --git a/t/t5523-push-upstream.sh b/t/t5523-push-upstream.sh
index 554f55e..113626b 100755
--- a/t/t5523-push-upstream.sh
+++ b/t/t5523-push-upstream.sh
@@ -72,7 +72,7 @@ test_expect_success 'push -u HEAD' '
 	check_config headbranch upstream refs/heads/headbranch
 '
 
-test_expect_failure 'progress messages to non-tty' '
+test_expect_success 'progress messages to non-tty' '
 	ensure_fresh_upstream &&
 
 	# skip progress messages, since stderr is non-tty
@@ -80,7 +80,7 @@ test_expect_failure 'progress messages to non-tty' '
 	! grep "Writing objects" err
 '
 
-test_expect_failure 'progress messages to non-tty (forced)' '
+test_expect_success 'progress messages to non-tty (forced)' '
 	ensure_fresh_upstream &&
 
 	# force progress messages to stderr, even though it is non-tty
diff --git a/transport.c b/transport.c
index 4dba6f8..0078660 100644
--- a/transport.c
+++ b/transport.c
@@ -789,6 +789,7 @@ static int git_transport_push(struct transport *transport, struct ref *remote_re
 	args.use_thin_pack = data->options.thin;
 	args.verbose = (transport->verbose > 0);
 	args.quiet = (transport->verbose < 0);
+	args.progress = transport->progress;
 	args.dry_run = !!(flags & TRANSPORT_PUSH_DRY_RUN);
 	args.porcelain = !!(flags & TRANSPORT_PUSH_PORCELAIN);
 
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-13 19:35

Subject: Re: [PATCH 0/3] fix push --progress over file://, git://, etc.
Message-ID: <AANLkTimo=Bd_XGvX=TPzVsds3xQGy9126+7Qg+zvk=d2@mail.gmail.com>
URL: https://gitlist.dev/e/AANLkTimo%3DBd_XGvX%3DTPzVsds3xQGy9126%2B7Qg%2Bzvk%3Dd2%40mail.gmail.com
In-Reply-To: <1286998311-5112-1-git-send-email-rctay89@gmail.com>

```
On Thu, Oct 14, 2010 at 3:31 AM, Tay Ray Chuan <rctay89@gmail.com> wrote:
> *** BLURB HERE ***

Whoops. Let me try again:

This patch series addresses the issue of git push not displaying
progress messages to non-tty stderr, even if --progress is used. As
suggested by the subject, this issue afflicts the "builtin smart
transports" - file://, git://, ssh://. (All of them use
git_transport_push() and thus git-pack-objects.)

-- 
Cheers,
Ray Chuan

```

## Tay Ray Chuan, 2010-10-14 00:59

Subject: Re: [PATCH 3/3] push: pass --progress down to git-pack-objects
Message-ID: <AANLkTikUne3NmDMEsq07oN+4pr9APQJFKhF-FKLmSUbh@mail.gmail.com>
URL: https://gitlist.dev/e/AANLkTikUne3NmDMEsq07oN%2B4pr9APQJFKhF-FKLmSUbh%40mail.gmail.com
In-Reply-To: <1286998311-5112-4-git-send-email-rctay89@gmail.com>

```
Hi,

On Thu, Oct 14, 2010 at 3:31 AM, Tay Ray Chuan <rctay89@gmail.com> wrote:
> From: Jeff King <peff@peff.net>
>
> [snip]
>
> Reported-by: Chase Brammer <cbrammer@gmail.com>
> Helped-by: Jonathan Nieder <jrnieder@gmail.com>
> Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>

Chase, I switched the authorship to Jeff - after all, he was the one
who wrote the patch. I hope you're fine with that.

Jeff, if this patch is ok, since you're the author, perhaps you might
want to add your SOB?

-- 
Cheers,
Ray Chuan

```

## Jeff King, 2010-10-14 01:24

Subject: Re: [PATCH 3/3] push: pass --progress down to git-pack-objects
Message-ID: <20101014012415.GA20685@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101014012415.GA20685%40sigill.intra.peff.net
In-Reply-To: <AANLkTikUne3NmDMEsq07oN+4pr9APQJFKhF-FKLmSUbh@mail.gmail.com>

```
On Thu, Oct 14, 2010 at 08:59:41AM +0800, Tay Ray Chuan wrote:

> On Thu, Oct 14, 2010 at 3:31 AM, Tay Ray Chuan <rctay89@gmail.com> wrote:
> > From: Jeff King <peff@peff.net>
> >
> > [snip]
> >
> > Reported-by: Chase Brammer <cbrammer@gmail.com>
> > Helped-by: Jonathan Nieder <jrnieder@gmail.com>
> > Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
> 
> Chase, I switched the authorship to Jeff - after all, he was the one
> who wrote the patch. I hope you're fine with that.
> 
> Jeff, if this patch is ok, since you're the author, perhaps you might
> want to add your SOB?

Yeah, definitely:

Signed-off-by: Jeff King <peff@peff.net>

-Peff

```

## Jeff King, 2010-10-14 03:02

Subject: [PATCH 0/3] more push progress tests
Message-ID: <20101014030220.GB20685@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101014030220.GB20685%40sigill.intra.peff.net
In-Reply-To: <1286998311-5112-1-git-send-email-rctay89@gmail.com>

```
On Thu, Oct 14, 2010 at 03:31:48AM +0800, Tay Ray Chuan wrote:

> [PATCH 1/3] t5523-push-upstream: add function to ensure fresh upstream repo
> [PATCH 2/3] t5523-push-upstream: test progress messages
> [PATCH 3/3] push: pass --progress down to git-pack-objects

I had hoped to have a fix for --no-progress, but munging the tests took
so long that now I am sleepy. :) So here are some extra tests on top of
your series. The first two are refactoring, and the third has the new
tests. It checks regular stderr-is-tty progress and that "push -q"
suppresses progress, as Junio asked elsewhere. And it reveals the bug in
--no-progress.

It might make more sense to actually re-roll your series with the
refactoring at the front, and my 3/3 squashed into your 2/3.

Also, these tests feel a bit out of place in t5523, but I don't see a
better place for them to go. Perhaps they should go in their own test
script. I don't feel strongly, though.

  [1/3]: tests: factor out terminal handling from t7006
  [2/3]: tests: test terminal output to both stdout and stderr
  [3/3]: t5523: test push progress output to tty

-Peff

```

## Jeff King, 2010-10-14 03:04

Subject: [PATCH 1/3] tests: factor out terminal handling from t7006
Message-ID: <20101014030403.GA5626@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101014030403.GA5626%40sigill.intra.peff.net
In-Reply-To: <20101014030220.GB20685@sigill.intra.peff.net>

```
Other tests besides the pager ones may want to check how we handle
output to a terminal. This patch makes the code reusable.

Signed-off-by: Jeff King <peff@peff.net>
---
 t/lib-terminal.sh                |   28 ++++++++++++++++++++++++++++
 t/t7006-pager.sh                 |   31 +------------------------------
 t/{t7006 => }/test-terminal.perl |    0
 3 files changed, 29 insertions(+), 30 deletions(-)
 create mode 100644 t/lib-terminal.sh
 rename t/{t7006 => }/test-terminal.perl (100%)

diff --git a/t/lib-terminal.sh b/t/lib-terminal.sh
new file mode 100644
index 0000000..6fc33db
--- /dev/null
+++ b/t/lib-terminal.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+
+test_expect_success 'set up terminal for tests' '
+	if test -t 1
+	then
+		>stdout_is_tty
+	elif
+		test_have_prereq PERL &&
+		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl \
+			sh -c "test -t 1"
+	then
+		>test_terminal_works
+	fi
+'
+
+if test -e stdout_is_tty
+then
+	test_terminal() { "$@"; }
+	test_set_prereq TTY
+elif test -e test_terminal_works
+then
+	test_terminal() {
+		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl "$@"
+	}
+	test_set_prereq TTY
+else
+	say "# no usable terminal, so skipping some tests"
+fi
diff --git a/t/t7006-pager.sh b/t/t7006-pager.sh
index fb744e3..17e54d3 100755
--- a/t/t7006-pager.sh
+++ b/t/t7006-pager.sh
@@ -4,42 +4,13 @@ test_description='Test automatic use of a pager.'
 
 . ./test-lib.sh
 . "$TEST_DIRECTORY"/lib-pager.sh
+. "$TEST_DIRECTORY"/lib-terminal.sh
 
 cleanup_fail() {
 	echo >&2 cleanup failed
 	(exit 1)
 }
 
-test_expect_success 'set up terminal for tests' '
-	rm -f stdout_is_tty ||
-	cleanup_fail &&
-
-	if test -t 1
-	then
-		>stdout_is_tty
-	elif
-		test_have_prereq PERL &&
-		"$PERL_PATH" "$TEST_DIRECTORY"/t7006/test-terminal.perl \
-			sh -c "test -t 1"
-	then
-		>test_terminal_works
-	fi
-'
-
-if test -e stdout_is_tty
-then
-	test_terminal() { "$@"; }
-	test_set_prereq TTY
-elif test -e test_terminal_works
-then
-	test_terminal() {
-		"$PERL_PATH" "$TEST_DIRECTORY"/t7006/test-terminal.perl "$@"
-	}
-	test_set_prereq TTY
-else
-	say "# no usable terminal, so skipping some tests"
-fi
-
 test_expect_success 'setup' '
 	unset GIT_PAGER GIT_PAGER_IN_USE;
 	test_might_fail git config --unset core.pager &&
diff --git a/t/t7006/test-terminal.perl b/t/test-terminal.perl
similarity index 100%
rename from t/t7006/test-terminal.perl
rename to t/test-terminal.perl
-- 
1.7.3.1.204.g337d6.dirty

```

## Jeff King, 2010-10-14 03:04

Subject: [PATCH 2/3] tests: test terminal output to both stdout and stderr
Message-ID: <20101014030443.GB5626@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101014030443.GB5626%40sigill.intra.peff.net
In-Reply-To: <20101014030220.GB20685@sigill.intra.peff.net>

```
Some outputs (like the pager) care whether stdout is a
terminal. Others (like progress meters) care about stderr.

This patch sets up both. Technically speaking, we could go
further and set up just one (because either the other goes
to a terminal, or because our tests are only interested in
one). This patch does both to keep the interface to
lib-terminal simple.

Signed-off-by: Jeff King <peff@peff.net>
---
 t/lib-terminal.sh    |    8 ++++----
 t/test-terminal.perl |   31 ++++++++++++++++++++++++-------
 2 files changed, 28 insertions(+), 11 deletions(-)

diff --git a/t/lib-terminal.sh b/t/lib-terminal.sh
index 6fc33db..3258b8f 100644
--- a/t/lib-terminal.sh
+++ b/t/lib-terminal.sh
@@ -1,19 +1,19 @@
 #!/bin/sh
 
 test_expect_success 'set up terminal for tests' '
-	if test -t 1
+	if test -t 1 && test -t 2
 	then
-		>stdout_is_tty
+		>have_tty
 	elif
 		test_have_prereq PERL &&
 		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl \
-			sh -c "test -t 1"
+			sh -c "test -t 1 && test -t 2"
 	then
 		>test_terminal_works
 	fi
 '
 
-if test -e stdout_is_tty
+if test -e have_tty
 then
 	test_terminal() { "$@"; }
 	test_set_prereq TTY
diff --git a/t/test-terminal.perl b/t/test-terminal.perl
index 73ff809..c2e9dac 100755
--- a/t/test-terminal.perl
+++ b/t/test-terminal.perl
@@ -4,14 +4,15 @@ use warnings;
 use IO::Pty;
 use File::Copy;
 
-# Run @$argv in the background with stdout redirected to $out.
+# Run @$argv in the background with stdio redirected to $out and $err.
 sub start_child {
-	my ($argv, $out) = @_;
+	my ($argv, $out, $err) = @_;
 	my $pid = fork;
 	if (not defined $pid) {
 		die "fork failed: $!"
 	} elsif ($pid == 0) {
 		open STDOUT, ">&", $out;
+		open STDERR, ">&", $err;
 		close $out;
 		exec(@$argv) or die "cannot exec '$argv->[0]': $!"
 	}
@@ -47,12 +48,28 @@ sub xsendfile {
 	copy($in, $out, 4096) or $!{EIO} or die "cannot copy from child: $!";
 }
 
+sub copy_stdio {
+	my ($out, $err) = @_;
+	my $pid = fork;
+	defined $pid or die "fork failed: $!";
+	if (!$pid) {
+		close($out);
+		xsendfile(\*STDERR, $err);
+		exit 0;
+	}
+	close($err);
+	xsendfile(\*STDOUT, $out);
+	finish_child($pid) == 0
+		or exit 1;
+}
+
 if ($#ARGV < 1) {
 	die "usage: test-terminal program args";
 }
-my $master = new IO::Pty;
-my $slave = $master->slave;
-my $pid = start_child(\@ARGV, $slave);
-close $slave;
-xsendfile(\*STDOUT, $master);
+my $master_out = new IO::Pty;
+my $master_err = new IO::Pty;
+my $pid = start_child(\@ARGV, $master_out->slave, $master_err->slave);
+close $master_out->slave;
+close $master_err->slave;
+copy_stdio($master_out, $master_err);
 exit(finish_child($pid));
-- 
1.7.3.1.204.g337d6.dirty

```

## Jeff King, 2010-10-14 03:05

Subject: [PATCH 3/3] t5523: test push progress output to tty
Message-ID: <20101014030505.GC5626@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101014030505.GC5626%40sigill.intra.peff.net
In-Reply-To: <20101014030220.GB20685@sigill.intra.peff.net>

```
We already test the non-tty cases, but until recent changes
made lib-terminal.sh available, we couldn't test the case
with a tty. These tests reveal a bug: --no-progress is
silently ignored.

Signed-off-by: Jeff King <peff@peff.net>
---
 t/t5523-push-upstream.sh |   26 ++++++++++++++++++++++++--
 1 files changed, 24 insertions(+), 2 deletions(-)

diff --git a/t/t5523-push-upstream.sh b/t/t5523-push-upstream.sh
index 113626b..78c5978 100755
--- a/t/t5523-push-upstream.sh
+++ b/t/t5523-push-upstream.sh
@@ -2,6 +2,7 @@
 
 test_description='push with --set-upstream'
 . ./test-lib.sh
+. "$TEST_DIRECTORY"/lib-terminal.sh
 
 ensure_fresh_upstream() {
 	test -d parent &&
@@ -72,7 +73,14 @@ test_expect_success 'push -u HEAD' '
 	check_config headbranch upstream refs/heads/headbranch
 '
 
-test_expect_success 'progress messages to non-tty' '
+test_expect_success 'progress messages go to tty' '
+	ensure_fresh_upstream &&
+
+	test_terminal git push -u upstream master >out 2>err &&
+	grep "Writing objects" err
+'
+
+test_expect_success 'progress messages do not go to non-tty' '
 	ensure_fresh_upstream &&
 
 	# skip progress messages, since stderr is non-tty
@@ -80,7 +88,7 @@ test_expect_success 'progress messages to non-tty' '
 	! grep "Writing objects" err
 '
 
-test_expect_success 'progress messages to non-tty (forced)' '
+test_expect_success 'progress messages go to non-tty (forced)' '
 	ensure_fresh_upstream &&
 
 	# force progress messages to stderr, even though it is non-tty
@@ -88,4 +96,18 @@ test_expect_success 'progress messages to non-tty (forced)' '
 	grep "Writing objects" err
 '
 
+test_expect_success 'push -q suppresses progress' '
+	ensure_fresh_upstream &&
+
+	test_terminal git push -u -q upstream master >out 2>err &&
+	! grep "Writing objects" err
+'
+
+test_expect_failure 'push --no-progress suppresses progress' '
+	ensure_fresh_upstream &&
+
+	test_terminal git push -u --no-progress upstream master >out 2>err &&
+	! grep "Writing objects" err
+'
+
 test_done
-- 
1.7.3.1.204.g337d6.dirty

```

## Jonathan Nieder, 2010-10-14 03:10

Subject: Re: [PATCH 1/3] tests: factor out terminal handling from t7006
Message-ID: <20101014031014.GA14664@burratino>
URL: https://gitlist.dev/e/20101014031014.GA14664%40burratino
In-Reply-To: <20101014030403.GA5626@sigill.intra.peff.net>

```
Jeff King wrote:

> Other tests besides the pager ones may want to check how we handle
> output to a terminal. This patch makes the code reusable.
> 
> Signed-off-by: Jeff King <peff@peff.net>

Thanks!  Looks good to me.

```

## Jonathan Nieder, 2010-10-14 03:16

Subject: Re: [PATCH 3/3] t5523: test push progress output to tty
Message-ID: <20101014031642.GB14664@burratino>
URL: https://gitlist.dev/e/20101014031642.GB14664%40burratino
In-Reply-To: <20101014030505.GC5626@sigill.intra.peff.net>

```
Jeff King wrote:

> --- a/t/t5523-push-upstream.sh
> +++ b/t/t5523-push-upstream.sh
[...]
> @@ -72,7 +73,14 @@ test_expect_success 'push -u HEAD' '
>  	check_config headbranch upstream refs/heads/headbranch
>  '
>  
> -test_expect_success 'progress messages to non-tty' '
> +test_expect_success 'progress messages go to tty' '
> +	ensure_fresh_upstream &&
> +
> +	test_terminal git push -u upstream master >out 2>err &&
> +	grep "Writing objects" err
> +'

Missing TTY prerequisite.  (Do you think test_terminal should check
$prereq to prevent this?)

> @@ -88,4 +96,18 @@ test_expect_success 'progress messages to non-tty (forced)' '
>  	grep "Writing objects" err
>  '
>  
> +test_expect_success 'push -q suppresses progress' '
> +	ensure_fresh_upstream &&
> +
> +	test_terminal git push -u -q upstream master >out 2>err &&
> +	! grep "Writing objects" err
> +'

Likewise.

> +
> +test_expect_failure 'push --no-progress suppresses progress' '
> +	ensure_fresh_upstream &&
> +
> +	test_terminal git push -u --no-progress upstream master >out 2>err &&
> +	! grep "Writing objects" err
> +'

Likewise.

Regards,
Jonathan

```

## Jonathan Nieder, 2010-10-14 03:27

Subject: Re: [PATCH 2/3] tests: test terminal output to both stdout and stderr
Message-ID: <20101014032734.GC14664@burratino>
URL: https://gitlist.dev/e/20101014032734.GC14664%40burratino
In-Reply-To: <20101014030443.GB5626@sigill.intra.peff.net>

```
Jeff King wrote:

> Some outputs (like the pager) care whether stdout is a
> terminal. Others (like progress meters) care about stderr.
> 
> This patch sets up both. Technically speaking, we could go
> further and set up just one (because either the other goes
> to a terminal, or because our tests are only interested in
> one).

This makes test_terminal more realistic, too: the usual case is for
stdout and stderr to go to a terminal (unless explicitly captured or
redirected).

Tests can use 'test_terminal sh -c "foo >/dev/null"' to test that a
command correctly handles being run with stderr a terminal and
stdout not.

And I doubt this would make test_terminal much slower.

So for what it's worth:
Acked-by: Jonathan Nieder <jrnieder@gmail.com>

Thanks.

```

## Jeff King, 2010-10-14 03:34

Subject: Re: [PATCH 3/3] t5523: test push progress output to tty
Message-ID: <20101014033448.GB28197@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101014033448.GB28197%40sigill.intra.peff.net
In-Reply-To: <20101014031642.GB14664@burratino>

```
On Wed, Oct 13, 2010 at 10:16:42PM -0500, Jonathan Nieder wrote:

> Jeff King wrote:
> 
> > --- a/t/t5523-push-upstream.sh
> > +++ b/t/t5523-push-upstream.sh
> [...]
> > @@ -72,7 +73,14 @@ test_expect_success 'push -u HEAD' '
> >  	check_config headbranch upstream refs/heads/headbranch
> >  '
> >  
> > -test_expect_success 'progress messages to non-tty' '
> > +test_expect_success 'progress messages go to tty' '
> > +	ensure_fresh_upstream &&
> > +
> > +	test_terminal git push -u upstream master >out 2>err &&
> > +	grep "Writing objects" err
> > +'
> 
> Missing TTY prerequisite.  (Do you think test_terminal should check
> $prereq to prevent this?)

Oops, good catch. I think we should already catch it, as test_terminal
will not be defined at all in the no-tty case. We could print a nicer
message, but it is not likely to be seen by the user. If they are
using "-v", then stderr probably _is_ a tty. And if not, they will not
see the message. There are ways around it, but they are not likely to be
seen unless the user is really trying (e.g., "./t5523-* -v >not_a_tty").

-Peff

```

## Jonathan Nieder, 2010-10-14 20:37

Subject: [PATCH/RFC 0/2] test_terminal: check that TTY prerequisite is declared
Message-ID: <20101014203721.GA28958@burratino>
URL: https://gitlist.dev/e/20101014203721.GA28958%40burratino
In-Reply-To: <20101014033448.GB28197@sigill.intra.peff.net>

```
Jeff King wrote:
> On Wed, Oct 13, 2010 at 10:16:42PM -0500, Jonathan Nieder wrote:

>> Missing TTY prerequisite.  (Do you think test_terminal should check
>> $prereq to prevent this?)
>
> Oops, good catch. I think we should already catch it, as test_terminal
> will not be defined at all in the no-tty case. We could print a nicer
> message, but

I rather meant something like this.

Patch 1 exposes the internal $prereq variable from
test_expect_(success|failure).  Maybe it should be called
GIT_TEST_something to avoid trampling other programs' namespaces?  Not
sure.

Patch 2 introduces some magic autodetection so people that never run
tests without -v can still notice the missing TTY prereqs.

Jonathan Nieder (2):
  test-lib: allow test code to check the list of declared prerequisites
  test_terminal: catch use without TTY prerequisite

 t/t7006-pager.sh |   20 ++++++++++++--------
 t/test-lib.sh    |   26 +++++++++++++++++++-------
 2 files changed, 31 insertions(+), 15 deletions(-)

-- 
1.7.2.3

```

## Jonathan Nieder, 2010-10-14 20:40

Subject: [PATCH 1/2] test-lib: allow test code to check the list of declared prerequisites
Message-ID: <20101014204001.GB28958@burratino>
URL: https://gitlist.dev/e/20101014204001.GB28958%40burratino
In-Reply-To: <20101014203721.GA28958@burratino>

```
This is plumbing to prepare helpers like test_terminal to notice buggy
test scripts that do not declare all of the necessary prerequisites.

Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
---
Applies on top of 892e6f7 (test-lib: make test_expect_code a test
command) from the en/and-cascade-tests branch.  On master,
text_expect_code would have to be adjusted, too.

 t/test-lib.sh |   26 +++++++++++++++++++-------
 1 files changed, 19 insertions(+), 7 deletions(-)

diff --git a/t/test-lib.sh b/t/test-lib.sh
index d86edcd..cd69ffa 100644
--- a/t/test-lib.sh
+++ b/t/test-lib.sh
@@ -362,6 +362,15 @@ test_have_prereq () {
 	test $total_prereq = $ok_prereq
 }
 
+test_declared_prereq () {
+	case ",$test_prereq," in
+	*,$1,*)
+		return 0
+		;;
+	esac
+	return 1
+}
+
 # You are not expected to call test_ok_ and test_failure_ directly, use
 # the text_expect_* functions instead.
 
@@ -414,17 +423,17 @@ test_skip () {
 			break
 		esac
 	done
-	if test -z "$to_skip" && test -n "$prereq" &&
-	   ! test_have_prereq "$prereq"
+	if test -z "$to_skip" && test -n "$test_prereq" &&
+	   ! test_have_prereq "$test_prereq"
 	then
 		to_skip=t
 	fi
 	case "$to_skip" in
 	t)
 		of_prereq=
-		if test "$missing_prereq" != "$prereq"
+		if test "$missing_prereq" != "$test_prereq"
 		then
-			of_prereq=" of $prereq"
+			of_prereq=" of $test_prereq"
 		fi
 
 		say_color skip >&3 "skipping test: $@"
@@ -438,9 +447,10 @@ test_skip () {
 }
 
 test_expect_failure () {
-	test "$#" = 3 && { prereq=$1; shift; } || prereq=
+	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 	test "$#" = 2 ||
 	error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
+	export test_prereq
 	if ! test_skip "$@"
 	then
 		say >&3 "checking known breakage: $2"
@@ -456,9 +466,10 @@ test_expect_failure () {
 }
 
 test_expect_success () {
-	test "$#" = 3 && { prereq=$1; shift; } || prereq=
+	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 	test "$#" = 2 ||
 	error "bug in the test script: not 2 or 3 parameters to test-expect-success"
+	export test_prereq
 	if ! test_skip "$@"
 	then
 		say >&3 "expecting success: $2"
@@ -482,11 +493,12 @@ test_expect_success () {
 # Usage: test_external description command arguments...
 # Example: test_external 'Perl API' perl ../path/to/test.pl
 test_external () {
-	test "$#" = 4 && { prereq=$1; shift; } || prereq=
+	test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 	test "$#" = 3 ||
 	error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 	descr="$1"
 	shift
+	export test_prereq
 	if ! test_skip "$descr" "$@"
 	then
 		# Announce the script to reduce confusion about the
-- 
1.7.2.3

```

## Jonathan Nieder, 2010-10-14 20:41

Subject: [PATCH 2/2] test_terminal: catch use without TTY prerequisite
Message-ID: <20101014204141.GC28958@burratino>
URL: https://gitlist.dev/e/20101014204141.GC28958%40burratino
In-Reply-To: <20101014203721.GA28958@burratino>

```
It is easy to forget to declare the TTY prerequisite when
writing tests on a system where it would always be satisfied
(because IO::Pty is installed; see v1.7.3-rc0~33^2, 2010-08-16
for example).  Automatically detect this problem so there is
no need to remember.

	test_terminal: need to declare TTY prerequisite
	test_must_fail: command not found: test_terminal echo hi

test_terminal returns status 127 in this case to simulate
not being available.

Also replace the SIMPLEPAGERTTY prerequisite on one test with
"SIMPLEPAGER,TTY", since (1) the latter is supported now and
(2) the prerequisite detection relies on the TTY prereq being
explicitly declared.

Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
---
Penance for introducing that bug a few times.

 t/t7006-pager.sh |   20 ++++++++++++--------
 1 files changed, 12 insertions(+), 8 deletions(-)

diff --git a/t/t7006-pager.sh b/t/t7006-pager.sh
index fb744e3..53868f6 100755
--- a/t/t7006-pager.sh
+++ b/t/t7006-pager.sh
@@ -28,11 +28,11 @@ test_expect_success 'set up terminal for tests' '
 
 if test -e stdout_is_tty
 then
-	test_terminal() { "$@"; }
+	test_terminal_() { "$@"; }
 	test_set_prereq TTY
 elif test -e test_terminal_works
 then
-	test_terminal() {
+	test_terminal_() {
 		"$PERL_PATH" "$TEST_DIRECTORY"/t7006/test-terminal.perl "$@"
 	}
 	test_set_prereq TTY
@@ -40,6 +40,15 @@ else
 	say "# no usable terminal, so skipping some tests"
 fi
 
+test_terminal () {
+	if ! test_declared_prereq TTY
+	then
+		echo >&2 'test_terminal: need to declare TTY prerequisite'
+		return 127
+	fi
+	test_terminal_ "$@"
+}
+
 test_expect_success 'setup' '
 	unset GIT_PAGER GIT_PAGER_IN_USE;
 	test_might_fail git config --unset core.pager &&
@@ -213,11 +222,6 @@ test_expect_success 'color when writing to a file intended for a pager' '
 	colorful colorful.log
 '
 
-if test_have_prereq SIMPLEPAGER && test_have_prereq TTY
-then
-	test_set_prereq SIMPLEPAGERTTY
-fi
-
 # Use this helper to make it easy for the caller of your
 # terminal-using function to specify whether it should fail.
 # If you write
@@ -253,7 +257,7 @@ parse_args() {
 test_default_pager() {
 	parse_args "$@"
 
-	$test_expectation SIMPLEPAGERTTY "$cmd - default pager is used by default" "
+	$test_expectation SIMPLEPAGER,TTY "$cmd - default pager is used by default" "
 		unset PAGER GIT_PAGER;
 		test_might_fail git config --unset core.pager &&
 		rm -f default_pager_used ||
-- 
1.7.2.3

```

## Jeff King, 2010-10-15 04:42

Subject: Re: [PATCH/RFC 0/2] test_terminal: check that TTY prerequisite is declared
Message-ID: <20101015044252.GA22438@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101015044252.GA22438%40sigill.intra.peff.net
In-Reply-To: <20101014203721.GA28958@burratino>

```
On Thu, Oct 14, 2010 at 03:37:21PM -0500, Jonathan Nieder wrote:

> > Oops, good catch. I think we should already catch it, as test_terminal
> > will not be defined at all in the no-tty case. We could print a nicer
> > message, but
> 
> I rather meant something like this.
> 
> Patch 1 exposes the internal $prereq variable from
> test_expect_(success|failure).  Maybe it should be called
> GIT_TEST_something to avoid trampling other programs' namespaces?  Not
> sure.
> 
> Patch 2 introduces some magic autodetection so people that never run
> tests without -v can still notice the missing TTY prereqs.

Yeah, that is better, as it will catch the lack of prerequisite even on
systems where the prerequisite is met.

It seems like a lot of code to catch something small, but on the other
hand, it does seem to be a repeated mistake.

-Peff

```

## Ævar Arnfjörð Bjarmason, 2010-10-15 05:18

Subject: Re: [PATCH 1/2] test-lib: allow test code to check the list of declared prerequisites
Message-ID: <AANLkTikkWw4Ju4jJFtvKX+s2LMkveQX-uBQyS41A=Vh2@mail.gmail.com>
URL: https://gitlist.dev/e/AANLkTikkWw4Ju4jJFtvKX%2Bs2LMkveQX-uBQyS41A%3DVh2%40mail.gmail.com
In-Reply-To: <20101014204001.GB28958@burratino>

```
On Thu, Oct 14, 2010 at 20:40, Jonathan Nieder <jrnieder@gmail.com> wrote:

> +       case ",$test_prereq," in
> +       *,$1,*)

Won't this only work with:

    test_expect_success FOO,THINGYOUWANT,BAR '...'

And not:

    test_expect_success THINGYOUWANT,FOO,BAR '...'

?

```

## Jonathan Nieder, 2010-10-15 05:34

Subject: Re: [PATCH 1/2] test-lib: allow test code to check the list of declared prerequisites
Message-ID: <20101015053414.GC21830@burratino>
URL: https://gitlist.dev/e/20101015053414.GC21830%40burratino
In-Reply-To: <AANLkTikkWw4Ju4jJFtvKX+s2LMkveQX-uBQyS41A=Vh2@mail.gmail.com>

```
Ævar Arnfjörð Bjarmason wrote:
> On Thu, Oct 14, 2010 at 20:40, Jonathan Nieder <jrnieder@gmail.com> wrote:

>> +       case ",$test_prereq," in
>> +       *,$1,*)
>
> Won't this only work with:
> 
>     test_expect_success FOO,THINGYOUWANT,BAR '...'
> 
> And not:
> 
>     test_expect_success THINGYOUWANT,FOO,BAR '...'
> 
> ?

	$ case ,X,FOO,BAR, in
	  *,X,*)
		echo ok
		;;
	  *)
		echo not ok
		;;
	  esac
	ok
	$

Looks safe to me.  A * can match any string, including the empty string[1].

[1] http://www.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#tag_18_13_02

```

## Tay Ray Chuan, 2010-10-15 11:27

Subject: Re: [PATCH/RFC 0/2] test_terminal: check that TTY prerequisite is declared
Message-ID: <AANLkTi=Cvgu-761fQdhwbHhHJ6AgWYUSAbsOt=Cstji-@mail.gmail.com>
URL: https://gitlist.dev/e/AANLkTi%3DCvgu-761fQdhwbHhHJ6AgWYUSAbsOt%3DCstji-%40mail.gmail.com
In-Reply-To: <20101015044252.GA22438@sigill.intra.peff.net>

```
On Fri, Oct 15, 2010 at 12:42 PM, Jeff King <peff@peff.net> wrote:
> On Thu, Oct 14, 2010 at 03:37:21PM -0500, Jonathan Nieder wrote:
>
>> > Oops, good catch. I think we should already catch it, as test_terminal
>> > will not be defined at all in the no-tty case. We could print a nicer
>> > message, but
>>
>> I rather meant something like this.
>>
>> Patch 1 exposes the internal $prereq variable from
>> test_expect_(success|failure).  Maybe it should be called
>> GIT_TEST_something to avoid trampling other programs' namespaces?  Not
>> sure.
>>
>> Patch 2 introduces some magic autodetection so people that never run
>> tests without -v can still notice the missing TTY prereqs.
>
> Yeah, that is better, as it will catch the lack of prerequisite even on
> systems where the prerequisite is met.
>
> It seems like a lot of code to catch something small, but on the other
> hand, it does seem to be a repeated mistake.

I'll probably be re-rolling the push --progress fix series with this and Jeff's.

-- 
Cheers,
Ray Chuan

```

## Tay Ray Chuan, 2010-10-16 18:36

Subject: [PATCH v2 0/8] fix push --progress over file://, git://, etc.
Message-ID: <1287254223-4496-1-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-1-git-send-email-rctay89%40gmail.com
In-Reply-To: <AANLkTimo=Bd_XGvX=TPzVsds3xQGy9126+7Qg+zvk=d2@mail.gmail.com>

```
This patch series addresses the issue of git push not displaying
progress messages to non-tty stderr, even if --progress is used. As
suggested by the subject, this issue afflicts the "builtin smart
transports" - file://, git://, ssh://. (All of them use
git_transport_push() and thus git-pack-objects.)

The last patch contains the actual fix; most of the other patches
improve tests that depend on a tty.

Contents:
[PATCH v2 0/8] fix push --progress over file://, git://, etc.
[PATCH v2 1/8] tests: factor out terminal handling from t7006
[PATCH v2 2/8] tests: test terminal output to both stdout and stderr
[PATCH v2 3/8] test-lib: allow test code to check the list of declared prerequisites
[PATCH v2 4/8] test_terminal: catch use without TTY prerequisite
[PATCH v2 5/8] test_terminal: give priority to test-terminal.perl usage
[PATCH v2 6/8] t5523-push-upstream: add function to ensure fresh upstream repo
[PATCH v2 7/8] t5523-push-upstream: test progress messages
[PATCH v2 8/8] push: pass --progress down to git-pack-objects

Jeff King (3):
  tests: factor out terminal handling from t7006
  tests: test terminal output to both stdout and stderr
  push: pass --progress down to git-pack-objects

Jonathan Nieder (3):
  test-lib: allow test code to check the list of declared prerequisites
  test_terminal: catch use without TTY prerequisite
  test_terminal: give priority to test-terminal.perl usage

Tay Ray Chuan (2):
  t5523-push-upstream: add function to ensure fresh upstream repo
  t5523-push-upstream: test progress messages

 builtin/send-pack.c        |    3 ++
 send-pack.h                |    1 +
 t/lib-terminal.sh          |   39 +++++++++++++++++++++++
 t/t5523-push-upstream.sh   |   44 +++++++++++++++++++++++++-
 t/t7006-pager.sh           |   38 +---------------------
 t/t7006/test-terminal.perl |   58 ----------------------------------
 t/test-lib.sh              |   26 +++++++++++----
 t/test-terminal.perl       |   75 ++++++++++++++++++++++++++++++++++++++++++++
 transport.c                |    1 +
 9 files changed, 183 insertions(+), 102 deletions(-)
 create mode 100644 t/lib-terminal.sh
 delete mode 100755 t/t7006/test-terminal.perl
 create mode 100755 t/test-terminal.perl

-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:36

Subject: [PATCH v2 1/8] tests: factor out terminal handling from t7006
Message-ID: <1287254223-4496-2-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-2-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-1-git-send-email-rctay89@gmail.com>

```
From: Jeff King <peff@peff.net>

Other tests besides the pager ones may want to check how we handle
output to a terminal. This patch makes the code reusable.

Signed-off-by: Jeff King <peff@peff.net>
---

  No change.

 t/lib-terminal.sh          |   28 +++++++++++++++++++++
 t/t7006-pager.sh           |   31 +----------------------
 t/t7006/test-terminal.perl |   58 --------------------------------------------
 t/test-terminal.perl       |   58 ++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 87 insertions(+), 88 deletions(-)
 create mode 100644 t/lib-terminal.sh
 delete mode 100755 t/t7006/test-terminal.perl
 create mode 100755 t/test-terminal.perl

diff --git a/t/lib-terminal.sh b/t/lib-terminal.sh
new file mode 100644
index 0000000..6fc33db
--- /dev/null
+++ b/t/lib-terminal.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+
+test_expect_success 'set up terminal for tests' '
+	if test -t 1
+	then
+		>stdout_is_tty
+	elif
+		test_have_prereq PERL &&
+		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl \
+			sh -c "test -t 1"
+	then
+		>test_terminal_works
+	fi
+'
+
+if test -e stdout_is_tty
+then
+	test_terminal() { "$@"; }
+	test_set_prereq TTY
+elif test -e test_terminal_works
+then
+	test_terminal() {
+		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl "$@"
+	}
+	test_set_prereq TTY
+else
+	say "# no usable terminal, so skipping some tests"
+fi
diff --git a/t/t7006-pager.sh b/t/t7006-pager.sh
index fb744e3..17e54d3 100755
--- a/t/t7006-pager.sh
+++ b/t/t7006-pager.sh
@@ -4,42 +4,13 @@ test_description='Test automatic use of a pager.'
 
 . ./test-lib.sh
 . "$TEST_DIRECTORY"/lib-pager.sh
+. "$TEST_DIRECTORY"/lib-terminal.sh
 
 cleanup_fail() {
 	echo >&2 cleanup failed
 	(exit 1)
 }
 
-test_expect_success 'set up terminal for tests' '
-	rm -f stdout_is_tty ||
-	cleanup_fail &&
-
-	if test -t 1
-	then
-		>stdout_is_tty
-	elif
-		test_have_prereq PERL &&
-		"$PERL_PATH" "$TEST_DIRECTORY"/t7006/test-terminal.perl \
-			sh -c "test -t 1"
-	then
-		>test_terminal_works
-	fi
-'
-
-if test -e stdout_is_tty
-then
-	test_terminal() { "$@"; }
-	test_set_prereq TTY
-elif test -e test_terminal_works
-then
-	test_terminal() {
-		"$PERL_PATH" "$TEST_DIRECTORY"/t7006/test-terminal.perl "$@"
-	}
-	test_set_prereq TTY
-else
-	say "# no usable terminal, so skipping some tests"
-fi
-
 test_expect_success 'setup' '
 	unset GIT_PAGER GIT_PAGER_IN_USE;
 	test_might_fail git config --unset core.pager &&
diff --git a/t/t7006/test-terminal.perl b/t/t7006/test-terminal.perl
deleted file mode 100755
index 73ff809..0000000
--- a/t/t7006/test-terminal.perl
+++ /dev/null
@@ -1,58 +0,0 @@
-#!/usr/bin/perl
-use strict;
-use warnings;
-use IO::Pty;
-use File::Copy;
-
-# Run @$argv in the background with stdout redirected to $out.
-sub start_child {
-	my ($argv, $out) = @_;
-	my $pid = fork;
-	if (not defined $pid) {
-		die "fork failed: $!"
-	} elsif ($pid == 0) {
-		open STDOUT, ">&", $out;
-		close $out;
-		exec(@$argv) or die "cannot exec '$argv->[0]': $!"
-	}
-	return $pid;
-}
-
-# Wait for $pid to finish.
-sub finish_child {
-	# Simplified from wait_or_whine() in run-command.c.
-	my ($pid) = @_;
-
-	my $waiting = waitpid($pid, 0);
-	if ($waiting < 0) {
-		die "waitpid failed: $!";
-	} elsif ($? & 127) {
-		my $code = $? & 127;
-		warn "died of signal $code";
-		return $code - 128;
-	} else {
-		return $? >> 8;
-	}
-}
-
-sub xsendfile {
-	my ($out, $in) = @_;
-
-	# Note: the real sendfile() cannot read from a terminal.
-
-	# It is unspecified by POSIX whether reads
-	# from a disconnected terminal will return
-	# EIO (as in AIX 4.x, IRIX, and Linux) or
-	# end-of-file.  Either is fine.
-	copy($in, $out, 4096) or $!{EIO} or die "cannot copy from child: $!";
-}
-
-if ($#ARGV < 1) {
-	die "usage: test-terminal program args";
-}
-my $master = new IO::Pty;
-my $slave = $master->slave;
-my $pid = start_child(\@ARGV, $slave);
-close $slave;
-xsendfile(\*STDOUT, $master);
-exit(finish_child($pid));
diff --git a/t/test-terminal.perl b/t/test-terminal.perl
new file mode 100755
index 0000000..73ff809
--- /dev/null
+++ b/t/test-terminal.perl
@@ -0,0 +1,58 @@
+#!/usr/bin/perl
+use strict;
+use warnings;
+use IO::Pty;
+use File::Copy;
+
+# Run @$argv in the background with stdout redirected to $out.
+sub start_child {
+	my ($argv, $out) = @_;
+	my $pid = fork;
+	if (not defined $pid) {
+		die "fork failed: $!"
+	} elsif ($pid == 0) {
+		open STDOUT, ">&", $out;
+		close $out;
+		exec(@$argv) or die "cannot exec '$argv->[0]': $!"
+	}
+	return $pid;
+}
+
+# Wait for $pid to finish.
+sub finish_child {
+	# Simplified from wait_or_whine() in run-command.c.
+	my ($pid) = @_;
+
+	my $waiting = waitpid($pid, 0);
+	if ($waiting < 0) {
+		die "waitpid failed: $!";
+	} elsif ($? & 127) {
+		my $code = $? & 127;
+		warn "died of signal $code";
+		return $code - 128;
+	} else {
+		return $? >> 8;
+	}
+}
+
+sub xsendfile {
+	my ($out, $in) = @_;
+
+	# Note: the real sendfile() cannot read from a terminal.
+
+	# It is unspecified by POSIX whether reads
+	# from a disconnected terminal will return
+	# EIO (as in AIX 4.x, IRIX, and Linux) or
+	# end-of-file.  Either is fine.
+	copy($in, $out, 4096) or $!{EIO} or die "cannot copy from child: $!";
+}
+
+if ($#ARGV < 1) {
+	die "usage: test-terminal program args";
+}
+my $master = new IO::Pty;
+my $slave = $master->slave;
+my $pid = start_child(\@ARGV, $slave);
+close $slave;
+xsendfile(\*STDOUT, $master);
+exit(finish_child($pid));
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:36

Subject: [PATCH v2 2/8] tests: test terminal output to both stdout and stderr
Message-ID: <1287254223-4496-3-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-3-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-2-git-send-email-rctay89@gmail.com>

```
From: Jeff King <peff@peff.net>

Some outputs (like the pager) care whether stdout is a
terminal. Others (like progress meters) care about stderr.

This patch sets up both. Technically speaking, we could go
further and set up just one (because either the other goes
to a terminal, or because our tests are only interested in
one). This patch does both to keep the interface to
lib-terminal simple.

Signed-off-by: Jeff King <peff@peff.net>
---

  No change.

 t/lib-terminal.sh    |    8 ++++----
 t/test-terminal.perl |   31 ++++++++++++++++++++++++-------
 2 files changed, 28 insertions(+), 11 deletions(-)

diff --git a/t/lib-terminal.sh b/t/lib-terminal.sh
index 6fc33db..3258b8f 100644
--- a/t/lib-terminal.sh
+++ b/t/lib-terminal.sh
@@ -1,19 +1,19 @@
 #!/bin/sh
 
 test_expect_success 'set up terminal for tests' '
-	if test -t 1
+	if test -t 1 && test -t 2
 	then
-		>stdout_is_tty
+		>have_tty
 	elif
 		test_have_prereq PERL &&
 		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl \
-			sh -c "test -t 1"
+			sh -c "test -t 1 && test -t 2"
 	then
 		>test_terminal_works
 	fi
 '
 
-if test -e stdout_is_tty
+if test -e have_tty
 then
 	test_terminal() { "$@"; }
 	test_set_prereq TTY
diff --git a/t/test-terminal.perl b/t/test-terminal.perl
index 73ff809..c2e9dac 100755
--- a/t/test-terminal.perl
+++ b/t/test-terminal.perl
@@ -4,14 +4,15 @@ use warnings;
 use IO::Pty;
 use File::Copy;
 
-# Run @$argv in the background with stdout redirected to $out.
+# Run @$argv in the background with stdio redirected to $out and $err.
 sub start_child {
-	my ($argv, $out) = @_;
+	my ($argv, $out, $err) = @_;
 	my $pid = fork;
 	if (not defined $pid) {
 		die "fork failed: $!"
 	} elsif ($pid == 0) {
 		open STDOUT, ">&", $out;
+		open STDERR, ">&", $err;
 		close $out;
 		exec(@$argv) or die "cannot exec '$argv->[0]': $!"
 	}
@@ -47,12 +48,28 @@ sub xsendfile {
 	copy($in, $out, 4096) or $!{EIO} or die "cannot copy from child: $!";
 }
 
+sub copy_stdio {
+	my ($out, $err) = @_;
+	my $pid = fork;
+	defined $pid or die "fork failed: $!";
+	if (!$pid) {
+		close($out);
+		xsendfile(\*STDERR, $err);
+		exit 0;
+	}
+	close($err);
+	xsendfile(\*STDOUT, $out);
+	finish_child($pid) == 0
+		or exit 1;
+}
+
 if ($#ARGV < 1) {
 	die "usage: test-terminal program args";
 }
-my $master = new IO::Pty;
-my $slave = $master->slave;
-my $pid = start_child(\@ARGV, $slave);
-close $slave;
-xsendfile(\*STDOUT, $master);
+my $master_out = new IO::Pty;
+my $master_err = new IO::Pty;
+my $pid = start_child(\@ARGV, $master_out->slave, $master_err->slave);
+close $master_out->slave;
+close $master_err->slave;
+copy_stdio($master_out, $master_err);
 exit(finish_child($pid));
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:36

Subject: [PATCH v2 3/8] test-lib: allow test code to check the list of declared prerequisites
Message-ID: <1287254223-4496-4-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-4-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-3-git-send-email-rctay89@gmail.com>

```
From: Jonathan Nieder <jrnieder@gmail.com>

This is plumbing to prepare helpers like test_terminal to notice buggy
test scripts that do not declare all of the necessary prerequisites.

Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
---

  No change.

 t/test-lib.sh |   26 +++++++++++++++++++-------
 1 files changed, 19 insertions(+), 7 deletions(-)

diff --git a/t/test-lib.sh b/t/test-lib.sh
index dff5e25..94bff17 100644
--- a/t/test-lib.sh
+++ b/t/test-lib.sh
@@ -362,6 +362,15 @@ test_have_prereq () {
 	test $total_prereq = $ok_prereq
 }
 
+test_declared_prereq () {
+	case ",$test_prereq," in
+	*,$1,*)
+		return 0
+		;;
+	esac
+	return 1
+}
+
 # You are not expected to call test_ok_ and test_failure_ directly, use
 # the text_expect_* functions instead.
 
@@ -414,17 +423,17 @@ test_skip () {
 			break
 		esac
 	done
-	if test -z "$to_skip" && test -n "$prereq" &&
-	   ! test_have_prereq "$prereq"
+	if test -z "$to_skip" && test -n "$test_prereq" &&
+	   ! test_have_prereq "$test_prereq"
 	then
 		to_skip=t
 	fi
 	case "$to_skip" in
 	t)
 		of_prereq=
-		if test "$missing_prereq" != "$prereq"
+		if test "$missing_prereq" != "$test_prereq"
 		then
-			of_prereq=" of $prereq"
+			of_prereq=" of $test_prereq"
 		fi
 
 		say_color skip >&3 "skipping test: $@"
@@ -438,9 +447,10 @@ test_skip () {
 }
 
 test_expect_failure () {
-	test "$#" = 3 && { prereq=$1; shift; } || prereq=
+	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 	test "$#" = 2 ||
 	error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
+	export test_prereq
 	if ! test_skip "$@"
 	then
 		say >&3 "checking known breakage: $2"
@@ -456,9 +466,10 @@ test_expect_failure () {
 }
 
 test_expect_success () {
-	test "$#" = 3 && { prereq=$1; shift; } || prereq=
+	test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 	test "$#" = 2 ||
 	error "bug in the test script: not 2 or 3 parameters to test-expect-success"
+	export test_prereq
 	if ! test_skip "$@"
 	then
 		say >&3 "expecting success: $2"
@@ -500,11 +511,12 @@ test_expect_code () {
 # Usage: test_external description command arguments...
 # Example: test_external 'Perl API' perl ../path/to/test.pl
 test_external () {
-	test "$#" = 4 && { prereq=$1; shift; } || prereq=
+	test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 	test "$#" = 3 ||
 	error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 	descr="$1"
 	shift
+	export test_prereq
 	if ! test_skip "$descr" "$@"
 	then
 		# Announce the script to reduce confusion about the
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:36

Subject: [PATCH v2 4/8] test_terminal: catch use without TTY prerequisite
Message-ID: <1287254223-4496-5-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-5-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-4-git-send-email-rctay89@gmail.com>

```
From: Jonathan Nieder <jrnieder@gmail.com>

It is easy to forget to declare the TTY prerequisite when
writing tests on a system where it would always be satisfied
(because IO::Pty is installed; see v1.7.3-rc0~33^2, 2010-08-16
for example).  Automatically detect this problem so there is
no need to remember.

	test_terminal: need to declare TTY prerequisite
	test_must_fail: command not found: test_terminal echo hi

test_terminal returns status 127 in this case to simulate
not being available.

Also replace the SIMPLEPAGERTTY prerequisite on one test with
"SIMPLEPAGER,TTY", since (1) the latter is supported now and
(2) the prerequisite detection relies on the TTY prereq being
explicitly declared.

Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
---

  Rebased on top of Jeff's series, so that lib-terminal's test_terminal is
  changed instead.

 t/lib-terminal.sh |   13 +++++++++++--
 t/t7006-pager.sh  |    7 +------
 2 files changed, 12 insertions(+), 8 deletions(-)

diff --git a/t/lib-terminal.sh b/t/lib-terminal.sh
index 3258b8f..5e7ee9a 100644
--- a/t/lib-terminal.sh
+++ b/t/lib-terminal.sh
@@ -15,14 +15,23 @@ test_expect_success 'set up terminal for tests' '
 
 if test -e have_tty
 then
-	test_terminal() { "$@"; }
+	test_terminal_() { "$@"; }
 	test_set_prereq TTY
 elif test -e test_terminal_works
 then
-	test_terminal() {
+	test_terminal_() {
 		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl "$@"
 	}
 	test_set_prereq TTY
 else
 	say "# no usable terminal, so skipping some tests"
 fi
+
+test_terminal () {
+	if ! test_declared_prereq TTY
+	then
+		echo >&2 'test_terminal: need to declare TTY prerequisite'
+		return 127
+	fi
+	test_terminal_ "$@"
+}
diff --git a/t/t7006-pager.sh b/t/t7006-pager.sh
index 17e54d3..5641b59 100755
--- a/t/t7006-pager.sh
+++ b/t/t7006-pager.sh
@@ -184,11 +184,6 @@ test_expect_success 'color when writing to a file intended for a pager' '
 	colorful colorful.log
 '
 
-if test_have_prereq SIMPLEPAGER && test_have_prereq TTY
-then
-	test_set_prereq SIMPLEPAGERTTY
-fi
-
 # Use this helper to make it easy for the caller of your
 # terminal-using function to specify whether it should fail.
 # If you write
@@ -224,7 +219,7 @@ parse_args() {
 test_default_pager() {
 	parse_args "$@"
 
-	$test_expectation SIMPLEPAGERTTY "$cmd - default pager is used by default" "
+	$test_expectation SIMPLEPAGER,TTY "$cmd - default pager is used by default" "
 		unset PAGER GIT_PAGER;
 		test_might_fail git config --unset core.pager &&
 		rm -f default_pager_used ||
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:37

Subject: [PATCH v2 5/8] test_terminal: give priority to test-terminal.perl usage
Message-ID: <1287254223-4496-6-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-6-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-5-git-send-email-rctay89@gmail.com>

```
From: Jonathan Nieder <jrnieder@gmail.com>

Tay Ray Chuan wrote:

> [snip]
> 2. For terminal tests that capture output/stderr, the TTY prerequisite
> warning does not quite work for things like
>
>   test_terminal foo >out 2>err
>
> because the warning gets "swallowed" up by the redirection that's
> supposed only to be done by the subcommand.

Good catch.  Such cases (like Jeff's patch) are not well supported
currently. :(

The outcome depends on whether stdout was already a terminal (in which
case test_terminal is a noop) or not (in which case test_terminal
introduces a pseudo-tty in the middle of the pipeline).

	$ test_terminal.perl sh -c 'test -t 1 && echo >&2 YES' >out
	YES
	$ sh -c 'test -t 1 && echo >&2 YES' >out
	$

How about this?

 - use the test_terminal script even when running with "-v"
   if IO::Pty is available, to allow commands like

	test_terminal foo >out 2>err

 - add a separate TTYREDIR prerequisite which is only set
   when the test_terminal script is usable

 - write the "need to declare TTY prerequisite" message to fd 4,
   where it will be printed when running tests with -v, rather
   than being swallowed up by an unrelated redireciton.

Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
---

  Picked up from a private discussion. I left the discussion in the
  patch message to give some background, and it also gives a nice
  summary of the changes.

 t/lib-terminal.sh |   24 +++++++++++++-----------
 1 files changed, 13 insertions(+), 11 deletions(-)

diff --git a/t/lib-terminal.sh b/t/lib-terminal.sh
index 5e7ee9a..71d147f 100644
--- a/t/lib-terminal.sh
+++ b/t/lib-terminal.sh
@@ -1,36 +1,38 @@
 #!/bin/sh
 
 test_expect_success 'set up terminal for tests' '
-	if test -t 1 && test -t 2
-	then
-		>have_tty
-	elif
+	if
 		test_have_prereq PERL &&
 		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl \
 			sh -c "test -t 1 && test -t 2"
 	then
 		>test_terminal_works
+	elif test -t 1 && test -t 2
+	then
+		>have_tty
 	fi
 '
 
-if test -e have_tty
-then
-	test_terminal_() { "$@"; }
-	test_set_prereq TTY
-elif test -e test_terminal_works
+if test -e test_terminal_works
 then
 	test_terminal_() {
 		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl "$@"
 	}
 	test_set_prereq TTY
+	test_set_prereq TTYREDIR
+elif test -e have_tty
+then
+	test_terminal_() { "$@"; }
+	test_set_prereq TTY
+
 else
 	say "# no usable terminal, so skipping some tests"
 fi
 
 test_terminal () {
-	if ! test_declared_prereq TTY
+	if ! test_declared_prereq TTY && ! test_declared_prereq TTYREDIR
 	then
-		echo >&2 'test_terminal: need to declare TTY prerequisite'
+		echo >&4 'test_terminal: need to declare TTY prerequisite'
 		return 127
 	fi
 	test_terminal_ "$@"
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:37

Subject: [PATCH v2 6/8] t5523-push-upstream: add function to ensure fresh upstream repo
Message-ID: <1287254223-4496-7-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-7-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-6-git-send-email-rctay89@gmail.com>

```
Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
---
 t/t5523-push-upstream.sh |    6 +++++-
 1 files changed, 5 insertions(+), 1 deletions(-)

diff --git a/t/t5523-push-upstream.sh b/t/t5523-push-upstream.sh
index 00da707..5a18533 100755
--- a/t/t5523-push-upstream.sh
+++ b/t/t5523-push-upstream.sh
@@ -3,8 +3,12 @@
 test_description='push with --set-upstream'
 . ./test-lib.sh
 
+ensure_fresh_upstream() {
+	rm -rf parent && git init --bare parent
+}
+
 test_expect_success 'setup bare parent' '
-	git init --bare parent &&
+	ensure_fresh_upstream &&
 	git remote add upstream parent
 '
 
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:37

Subject: [PATCH v2 7/8] t5523-push-upstream: test progress messages
Message-ID: <1287254223-4496-8-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-8-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-7-git-send-email-rctay89@gmail.com>

```
Reported-by: Chase Brammer <cbrammer@gmail.com>
Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
---

  Squashed in Jeff's additional tests, as well as added (missing) TTY
  pre-requisites pointed out by Johnathan.

 t/t5523-push-upstream.sh |   38 ++++++++++++++++++++++++++++++++++++++
 1 files changed, 38 insertions(+), 0 deletions(-)

diff --git a/t/t5523-push-upstream.sh b/t/t5523-push-upstream.sh
index 5a18533..f43d760 100755
--- a/t/t5523-push-upstream.sh
+++ b/t/t5523-push-upstream.sh
@@ -2,6 +2,7 @@
 
 test_description='push with --set-upstream'
 . ./test-lib.sh
+. "$TEST_DIRECTORY"/lib-terminal.sh
 
 ensure_fresh_upstream() {
 	rm -rf parent && git init --bare parent
@@ -70,4 +71,41 @@ test_expect_success 'push -u HEAD' '
 	check_config headbranch upstream refs/heads/headbranch
 '
 
+test_expect_success TTY 'progress messages go to tty' '
+	ensure_fresh_upstream &&
+
+	test_terminal git push -u upstream master >out 2>err &&
+	grep "Writing objects" err
+'
+
+test_expect_failure 'progress messages do not go to non-tty' '
+	ensure_fresh_upstream &&
+
+	# skip progress messages, since stderr is non-tty
+	git push -u upstream master >out 2>err &&
+	! grep "Writing objects" err
+'
+
+test_expect_failure 'progress messages go to non-tty (forced)' '
+	ensure_fresh_upstream &&
+
+	# force progress messages to stderr, even though it is non-tty
+	git push -u --progress upstream master >out 2>err &&
+	grep "Writing objects" err
+'
+
+test_expect_success TTY 'push -q suppresses progress' '
+	ensure_fresh_upstream &&
+
+	test_terminal git push -u -q upstream master >out 2>err &&
+	! grep "Writing objects" err
+'
+
+test_expect_failure TTY 'push --no-progress suppresses progress' '
+	ensure_fresh_upstream &&
+
+	test_terminal git push -u --no-progress upstream master >out 2>err &&
+	! grep "Writing objects" err
+'
+
 test_done
-- 
1.7.2.2.513.ge1ef3

```

## Tay Ray Chuan, 2010-10-16 18:37

Subject: [PATCH v2 8/8] push: pass --progress down to git-pack-objects
Message-ID: <1287254223-4496-9-git-send-email-rctay89@gmail.com>
URL: https://gitlist.dev/e/1287254223-4496-9-git-send-email-rctay89%40gmail.com
In-Reply-To: <1287254223-4496-8-git-send-email-rctay89@gmail.com>

```
From: Jeff King <peff@peff.net>

When pushing via builtin transports (like file://, git://), the
underlying transport helper (in this case, git-pack-objects) did not get
the --progress option, even if it was passed to git push.

Fix this, and update the tests to reflect this.

Note that according to the git-pack-objects documentation, we can safely
apply the usual --progress semantics for the transport commands like
clone and fetch (and for pushing over other smart transports).

Reported-by: Chase Brammer <cbrammer@gmail.com>
Helped-by: Jonathan Nieder <jrnieder@gmail.com>
Signed-off-by: Jeff King <peff@peff.net>
Signed-off-by: Tay Ray Chuan <rctay89@gmail.com>
---

  No significant changes other than those incurred while rebasing on
  top of Jeff's patches.

 builtin/send-pack.c      |    3 +++
 send-pack.h              |    1 +
 t/t5523-push-upstream.sh |    4 ++--
 transport.c              |    1 +
 4 files changed, 7 insertions(+), 2 deletions(-)

diff --git a/builtin/send-pack.c b/builtin/send-pack.c
index 481602d..efd9be6 100644
--- a/builtin/send-pack.c
+++ b/builtin/send-pack.c
@@ -48,6 +48,7 @@ static int pack_objects(int fd, struct ref *refs, struct extra_have_objects *ext
 		NULL,
 		NULL,
 		NULL,
+		NULL,
 	};
 	struct child_process po;
 	int i;
@@ -59,6 +60,8 @@ static int pack_objects(int fd, struct ref *refs, struct extra_have_objects *ext
 		argv[i++] = "--delta-base-offset";
 	if (args->quiet)
 		argv[i++] = "-q";
+	if (args->progress)
+		argv[i++] = "--progress";
 	memset(&po, 0, sizeof(po));
 	po.argv = argv;
 	po.in = -1;
diff --git a/send-pack.h b/send-pack.h
index 60b4ba6..05d7ab1 100644
--- a/send-pack.h
+++ b/send-pack.h
@@ -5,6 +5,7 @@ struct send_pack_args {
 	unsigned verbose:1,
 		quiet:1,
 		porcelain:1,
+		progress:1,
 		send_mirror:1,
 		force_update:1,
 		use_thin_pack:1,
diff --git a/t/t5523-push-upstream.sh b/t/t5523-push-upstream.sh
index f43d760..c229fe6 100755
--- a/t/t5523-push-upstream.sh
+++ b/t/t5523-push-upstream.sh
@@ -78,7 +78,7 @@ test_expect_success TTY 'progress messages go to tty' '
 	grep "Writing objects" err
 '
 
-test_expect_failure 'progress messages do not go to non-tty' '
+test_expect_success 'progress messages do not go to non-tty' '
 	ensure_fresh_upstream &&
 
 	# skip progress messages, since stderr is non-tty
@@ -86,7 +86,7 @@ test_expect_failure 'progress messages do not go to non-tty' '
 	! grep "Writing objects" err
 '
 
-test_expect_failure 'progress messages go to non-tty (forced)' '
+test_expect_success 'progress messages go to non-tty (forced)' '
 	ensure_fresh_upstream &&
 
 	# force progress messages to stderr, even though it is non-tty
diff --git a/transport.c b/transport.c
index 4dba6f8..0078660 100644
--- a/transport.c
+++ b/transport.c
@@ -789,6 +789,7 @@ static int git_transport_push(struct transport *transport, struct ref *remote_re
 	args.use_thin_pack = data->options.thin;
 	args.verbose = (transport->verbose > 0);
 	args.quiet = (transport->verbose < 0);
+	args.progress = transport->progress;
 	args.dry_run = !!(flags & TRANSPORT_PUSH_DRY_RUN);
 	args.porcelain = !!(flags & TRANSPORT_PUSH_PORCELAIN);
 
-- 
1.7.2.2.513.ge1ef3

```

## Jonathan Nieder, 2010-10-17 00:38

Subject: Re: [PATCH v2 5/8] test_terminal: give priority to test-terminal.perl usage
Message-ID: <20101017003807.GF20883@burratino>
URL: https://gitlist.dev/e/20101017003807.GF20883%40burratino
In-Reply-To: <1287254223-4496-6-git-send-email-rctay89@gmail.com>

```
Tay Ray Chuan wrote:

>  - use the test_terminal script even when running with "-v"
>    if IO::Pty is available, to allow commands like
> 
> 	test_terminal foo >out 2>err
> 
>  - add a separate TTYREDIR prerequisite which is only set
>    when the test_terminal script is usable
> 
>  - write the "need to declare TTY prerequisite" message to fd 4,
>    where it will be printed when running tests with -v, rather
>    than being swallowed up by an unrelated redireciton.

The patches up to this one look good to me.  This one behaves
as advertised, but I think the API is lousy --- it is just
begging people to use the TTY prereq where TTYREDIR is needed.

Better to change TTY to mean TTYREDIR and drop support for
test_terminal on systems without IO::Pty:

-- 8< --
Subject: test_terminal: ensure redirections work reliably

For terminal tests that capture output/stderr, the TTY prerequisite
warning does not quite work for commands like

	test_terminal foo >out 2>err

because the warning gets "swallowed" up by the redirection that's
supposed only to be done by the subcommand.

Even worse, the outcome depends on whether stdout was already a
terminal (in which case test_terminal is a noop) or not (in which case
test_terminal introduces a pseudo-tty in the middle of the pipeline).

	$ test_terminal.perl sh -c 'test -t 1 && echo >&2 YES' >out
	YES
	$ sh -c 'test -t 1 && echo >&2 YES' >out
	$

So:

 - use the test_terminal script even when running with "-v".

 - skip tests that require a terminal when the test_terminal
   script is unusable because IO::Pty is not installed.

 - write the "need to declare TTY prerequisite" message to fd 4,
   where it will be printed when running tests with -v, rather
   than being swallowed up by an unrelated redireciton.

Noticed-by: Tay Ray Chuan <rctay89@gmail.com>
Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
---
The only other sane alternative I can think of is to introduce
TTYNOREDIR, since at least people wouldn't be tempted to use
that.  Distinguishing between

	test_expect_success 'foo' '
		test_terminal bar >out 2>err
	'

and

	test_expect_success 'foo' '
		test_terminal bar
	'

from a script run as

	sh t1234-some-script.sh >log 2>err.log

does not seem to be easy without OS-specific hacks like
"readlink /dev/fd/1".

 t/lib-terminal.sh |   38 ++++++++++----------------------------
 1 files changed, 10 insertions(+), 28 deletions(-)

diff --git a/t/lib-terminal.sh b/t/lib-terminal.sh
index 5e7ee9a..c383b57 100644
--- a/t/lib-terminal.sh
+++ b/t/lib-terminal.sh
@@ -1,37 +1,19 @@
 #!/bin/sh
 
 test_expect_success 'set up terminal for tests' '
-	if test -t 1 && test -t 2
-	then
-		>have_tty
-	elif
+	if
 		test_have_prereq PERL &&
 		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl \
 			sh -c "test -t 1 && test -t 2"
 	then
-		>test_terminal_works
+		test_set_prereq TTY &&
+		test_terminal () {
+			if ! test_declared_prereq TTY
+			then
+				echo >&4 "test_terminal: need to declare TTY prerequisite"
+				return 127
+			fi
+			"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl "$@"
+		}
 	fi
 '
-
-if test -e have_tty
-then
-	test_terminal_() { "$@"; }
-	test_set_prereq TTY
-elif test -e test_terminal_works
-then
-	test_terminal_() {
-		"$PERL_PATH" "$TEST_DIRECTORY"/test-terminal.perl "$@"
-	}
-	test_set_prereq TTY
-else
-	say "# no usable terminal, so skipping some tests"
-fi
-
-test_terminal () {
-	if ! test_declared_prereq TTY
-	then
-		echo >&2 'test_terminal: need to declare TTY prerequisite'
-		return 127
-	fi
-	test_terminal_ "$@"
-}
-- 
1.7.2.3

```

## Jonathan Nieder, 2010-10-17 00:46

Subject: Re: [PATCH v2 7/8] t5523-push-upstream: test progress messages
Message-ID: <20101017004613.GG20883@burratino>
URL: https://gitlist.dev/e/20101017004613.GG20883%40burratino
In-Reply-To: <1287254223-4496-8-git-send-email-rctay89@gmail.com>

```
Tay Ray Chuan wrote:

[...]
> --- a/t/t5523-push-upstream.sh
> +++ b/t/t5523-push-upstream.sh
> @@ -70,4 +71,41 @@ test_expect_success 'push -u HEAD' '
>  	check_config headbranch upstream refs/heads/headbranch
>  '
>  
> +test_expect_success TTY 'progress messages go to tty' '
> +	ensure_fresh_upstream &&
> +
> +	test_terminal git push -u upstream master >out 2>err &&
> +	grep "Writing objects" err
> +'

Thanks for testing the usual case.  It is easy to forget sometimes.

The tests using the TTY prerequisite would need to use TTYREDIR
unless we simplify the latter out of existence.

```

## Jonathan Nieder, 2010-10-17 00:51

Subject: Re: [PATCH v2 0/8] fix push --progress over file://, git://, etc.
Message-ID: <20101017005107.GH20883@burratino>
URL: https://gitlist.dev/e/20101017005107.GH20883%40burratino
In-Reply-To: <1287254223-4496-1-git-send-email-rctay89@gmail.com>

```
Tay Ray Chuan wrote:

> Jeff King (3):
>   tests: factor out terminal handling from t7006
>   tests: test terminal output to both stdout and stderr
>   push: pass --progress down to git-pack-objects
> 
> Jonathan Nieder (3):
>   test-lib: allow test code to check the list of declared prerequisites
>   test_terminal: catch use without TTY prerequisite
>   test_terminal: give priority to test-terminal.perl usage
> 
> Tay Ray Chuan (2):
>   t5523-push-upstream: add function to ensure fresh upstream repo
>   t5523-push-upstream: test progress messages

I've sent some comments on patches 5 (give priority..) and 7 (test
progress messages).  Except as mentioned,

Reviewed-by: Jonathan Nieder <jrnieder@gmail.com>

Thanks for cleaning up the test_terminal mess.

```

## Jeff King, 2010-10-22 19:42

Subject: Re: [PATCH v2 5/8] test_terminal: give priority to test-terminal.perl usage
Message-ID: <20101022194252.GC13059@sigill.intra.peff.net>
URL: https://gitlist.dev/e/20101022194252.GC13059%40sigill.intra.peff.net
In-Reply-To: <1287254223-4496-6-git-send-email-rctay89@gmail.com>

```
On Sun, Oct 17, 2010 at 02:37:00AM +0800, Tay Ray Chuan wrote:

> The outcome depends on whether stdout was already a terminal (in which
> case test_terminal is a noop) or not (in which case test_terminal
> introduces a pseudo-tty in the middle of the pipeline).
> 
> 	$ test_terminal.perl sh -c 'test -t 1 && echo >&2 YES' >out
> 	YES
> 	$ sh -c 'test -t 1 && echo >&2 YES' >out
> 	$
> 
> How about this?
> 
>  - use the test_terminal script even when running with "-v"
>    if IO::Pty is available, to allow commands like
> 
> 	test_terminal foo >out 2>err
> 
>  - add a separate TTYREDIR prerequisite which is only set
>    when the test_terminal script is usable

Is it even worth keeping the direct-to-tty code at all? Yes, it means
that people without IO::Pty can use _some_ terminal tests with "-v". But
it creates a headache for test writers in understanding the subtle
difference between TTY and TTYREDIR.

-Peff

```
